| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Private Attributes | List of all members
ServiceHistory Class Reference

ServiceHistory class definition. More...

`#include <GaudiKernel/ServiceHistory.h>`

Inheritance diagram for ServiceHistory:
[legend]
Collaboration diagram for ServiceHistory:
[legend]

## Public Member Functions
| ServiceHistory ()
| ServiceHistory (const IService *, const JobHistory *)
| ServiceHistory (const IService &, const JobHistory *)
virtual | ~ServiceHistory ()=default
virtual const CLID & | clID () const
| Retrieve reference to class definition structure. More...
const PropertyList & | properties () const
const IService * | service () const
const JobHistory * | jobHistory () const
void | dump (std::ostream &, const bool isXML=false, int indent=0) const
const std::string & | name () const
const std::string & | type () const
const std::string & | version () const
Public Member Functions inherited from HistoryObj
| HistoryObj ()=default
virtual | ~HistoryObj ()=default
Public Member Functions inherited from DataObject
| DataObject ()
| Standard Constructor. More...
| DataObject (const DataObject &rhs)
| Copy Constructor. More...
DataObject & | operator= (const DataObject &rhs)
| Assignment Operator. More...
| DataObject (DataObject &&rhs)
| Move Constructor. More...
DataObject & | operator= (DataObject &&rhs)
| Move Assignment Operator. More...
virtual | ~DataObject ()
| Standard Destructor. More...
virtual unsigned long | addRef ()
| Add reference to object. More...
virtual unsigned long | release ()
| release reference to object More...
const std::string & | name () const
| Retreive DataObject name. It is the name when registered in the store. More...
virtual StatusCode | update ()
| Provide empty placeholder for internal object reconfiguration callback. More...
void | setRegistry (IRegistry *pRegistry)
| Set pointer to Registry. More...
IRegistry * | registry () const
| Get pointer to Registry. More...
LinkManager * | linkMgr () const
| Retrieve Link manager. More...
unsigned char | version () const
| Retrieve version number of this object representation. More...
void | setVersion (unsigned char vsn)
| Set version number of this object representation. More...
unsigned long | refCount () const
| Return the refcount. More...
virtual std::ostream & | fillStream (std::ostream &s) const
| Fill the output stream (ASCII) More...
Public Member Functions inherited from IVersHistoryObj
virtual | ~IVersHistoryObj ()=default

## Static Public Member Functions
static const CLID & | classID ()
Static Public Member Functions inherited from HistoryObj
static const CLID & | classID ()
static std::string | convert_string (const std::string &)
Static Public Member Functions inherited from DataObject
static const CLID & | classID ()
| Retrieve reference to class definition structure (static access) More...

## Private Attributes
const IService * | m_pService
const JobHistory * | m_jobHistory
std::string | m_name
std::string | m_type
std::string | m_version
PropertyList | m_properties

## Additional Inherited Members
Public Types inherited from IVersHistoryObj
typedef std::vector< Property * > | PropertyList
Protected Member Functions inherited from HistoryObj
virtual void | indent (std::ostream &, int) const

## Detailed Description

ServiceHistory class definition.

Author
  : Charles Leggett

Definition at line 22 of file ServiceHistory.h.

## Constructor & Destructor Documentation

ServiceHistory::ServiceHistory | ( |  | ) |

Definition at line 25 of file ServiceHistory.cpp.

25 :
26 // HistoryObj(),
27 m_pService(nullptr),
28 m_name("none"),
29 m_type("none"),
30 m_version("none")
31 {
32
33 }
ServiceHistory::m_name
std::string m_name
Definition: ServiceHistory.h:53
ServiceHistory::m_type
std::string m_type
Definition: ServiceHistory.h:53
ServiceHistory::m_version
std::string m_version
Definition: ServiceHistory.h:53
ServiceHistory::m_pService
const IService * m_pService
Definition: ServiceHistory.h:51

ServiceHistory::ServiceHistory | ( | const IService * | isv,
|  | const JobHistory * | job
| ) |  |

Definition at line 37 of file ServiceHistory.cpp.

37 :
38 // HistoryObj(),
39 m_pService(isv),
40 m_jobHistory(job),
41 m_name(isv->name()),
42 m_version("none")
43 {
44
45 const Service *svc = dynamic_cast<const Service*>(isv);
46 m_type = System::typeinfoName(typeid(*svc));
47 m_properties = svc->getProperties();
48
49 }
System::typeinfoName
GAUDI_API const std::string typeinfoName(const std::type_info &)
Get platform independent information about the class type.
Definition: System.cpp:297
ServiceHistory::m_name
std::string m_name
Definition: ServiceHistory.h:53
ServiceHistory::m_properties
PropertyList m_properties
Definition: ServiceHistory.h:54
Service::getProperties
const std::vector< Property * > & getProperties() const override
Definition: Service.cpp:354
ServiceHistory::m_type
std::string m_type
Definition: ServiceHistory.h:53
ServiceHistory::m_jobHistory
const JobHistory * m_jobHistory
Definition: ServiceHistory.h:52
ServiceHistory::m_version
std::string m_version
Definition: ServiceHistory.h:53
Service
Base class for all services.
Definition: Service.h:36
ServiceHistory::m_pService
const IService * m_pService
Definition: ServiceHistory.h:51

ServiceHistory::ServiceHistory | ( | const IService & | isv,
|  | const JobHistory * | job
| ) |  |

Definition at line 54 of file ServiceHistory.cpp.

54 :
55 // HistoryObj(),
56 m_pService(&isv),
57 m_jobHistory(job),
58 m_name(isv.name()),
59 m_version("none")
60 {
61
62 const Service *svc = dynamic_cast<const Service*>(&isv);
63 m_type = System::typeinfoName(typeid(*svc));
64 m_properties = svc->getProperties();
65
66 }
System::typeinfoName
GAUDI_API const std::string typeinfoName(const std::type_info &)
Get platform independent information about the class type.
Definition: System.cpp:297
ServiceHistory::m_name
std::string m_name
Definition: ServiceHistory.h:53
ServiceHistory::m_properties
PropertyList m_properties
Definition: ServiceHistory.h:54
Service::getProperties
const std::vector< Property * > & getProperties() const override
Definition: Service.cpp:354
ServiceHistory::m_type
std::string m_type
Definition: ServiceHistory.h:53
ServiceHistory::m_jobHistory
const JobHistory * m_jobHistory
Definition: ServiceHistory.h:52
ServiceHistory::m_version
std::string m_version
Definition: ServiceHistory.h:53
Service
Base class for all services.
Definition: Service.h:36
ServiceHistory::m_pService
const IService * m_pService
Definition: ServiceHistory.h:51

virtual ServiceHistory::~ServiceHistory | ( |  | ) |
| virtual default

## Member Function Documentation

const CLID & ServiceHistory::classID | ( |  | ) |
| static

Definition at line 71 of file ServiceHistory.cpp.

71 {
72
73 static const CLID CLID_ServiceHistory = 187225489; // from `clid ServiceHistory`
74 return CLID_ServiceHistory;
75
76 }
CLID
unsigned int CLID
Class ID definition.
Definition: ClassID.h:8

virtual const CLID& ServiceHistory::clID | ( |  | ) | const
| inline virtual

Retrieve reference to class definition structure.

Retrieve Pointer to class definition structure.

Reimplemented from HistoryObj.

Definition at line 32 of file ServiceHistory.h.

32 { return classID(); }
ServiceHistory::classID
static const CLID & classID()
Definition: ServiceHistory.cpp:71

void ServiceHistory::dump | ( | std::ostream & | ost,
|  | const bool | isXML = `false`,
|  | int | indent = `0`
| ) |  | const
| virtual

Implements HistoryObj.

Definition at line 81 of file ServiceHistory.cpp.

81 {
82
83 if (!isXML) {
84
85 ost << "Name: " << name() << endl;
86 ost << "Type: " << type() << endl;
87 ost << "Version: " << version() << endl;
88
89 //Properties
90 ost << "Properties: [" << endl;
91
92 for ( const auto& ipprop : properties() ) {
93 const Property& prop = *ipprop;
94 prop.fillStream(ost);
95 ost << endl;
96 }
97 ost << "]" << endl;
98
99 } else {
100
101 ind += 2;
102 indent(ost,ind);
103 ost << "<COMPONENT name=\"" << name()
104 << "\" class=\"" << convert_string(type())
105 << "\" version=\"" << convert_string(version())
106 << "\">" << endl;
107
108 for ( const auto& ipprop : properties() ) {
109 const Property& prop = *ipprop;
110
111 indent(ost,ind+2);
112 ost << "<PROPERTY name=\"" << prop.name()
113 << "\" value=\"" << convert_string(prop.toString())
114 << "\" documentation=\"" << convert_string(prop.documentation())
115 << "\">" << endl;
116 }
117
118 indent(ost,ind);
119 ost << "</COMPONENT>" << endl;
120
121 }
122
123 }
Property::toString
virtual std::string toString() const =0
value -> string
ServiceHistory::name
const std::string & name() const
Definition: ServiceHistory.h:44
Property::name
const std::string & name() const
property name
Definition: Property.h:45
std::endl
T endl(T...args)
Property::documentation
const std::string & documentation() const
property documentation
Definition: Property.h:47
Property::fillStream
virtual std::ostream & fillStream(std::ostream &) const
the printout of the property value
Definition: Property.cpp:111
ServiceHistory::version
const std::string & version() const
Definition: ServiceHistory.h:46
ServiceHistory::type
const std::string & type() const
Definition: ServiceHistory.h:45
HistoryObj::indent
virtual void indent(std::ostream &, int) const
Definition: HistoryObj.cpp:43
Property
Property base class allowing Property* collections to be "homogeneous".
Definition: Property.h:38
ServiceHistory::properties
const PropertyList & properties() const
Definition: ServiceHistory.h:36
HistoryObj::convert_string
static std::string convert_string(const std::string &)
Definition: HistoryObj.cpp:21

const JobHistory* ServiceHistory::jobHistory | ( |  | ) | const
| inline

Definition at line 40 of file ServiceHistory.h.

40 { return m_jobHistory; }
ServiceHistory::m_jobHistory
const JobHistory * m_jobHistory
Definition: ServiceHistory.h:52

const std::string& ServiceHistory::name | ( |  | ) | const
| inline virtual

Implements IVersHistoryObj.

Definition at line 44 of file ServiceHistory.h.

44 { return m_name; }
ServiceHistory::m_name
std::string m_name
Definition: ServiceHistory.h:53

const PropertyList& ServiceHistory::properties | ( |  | ) | const
| inline virtual

Implements IVersHistoryObj.

Definition at line 36 of file ServiceHistory.h.

36 { return m_properties; }
ServiceHistory::m_properties
PropertyList m_properties
Definition: ServiceHistory.h:54

const IService* ServiceHistory::service | ( |  | ) | const
| inline

Definition at line 38 of file ServiceHistory.h.

38 { return m_pService; }
ServiceHistory::m_pService
const IService * m_pService
Definition: ServiceHistory.h:51

const std::string& ServiceHistory::type | ( |  | ) | const
| inline virtual

Implements IVersHistoryObj.

Definition at line 45 of file ServiceHistory.h.

45 { return m_type; }
ServiceHistory::m_type
std::string m_type
Definition: ServiceHistory.h:53

const std::string& ServiceHistory::version | ( |  | ) | const
| inline virtual

Implements IVersHistoryObj.

Definition at line 46 of file ServiceHistory.h.

46 { return m_version; }
ServiceHistory::m_version
std::string m_version
Definition: ServiceHistory.h:53

## Member Data Documentation

const JobHistory* ServiceHistory::m_jobHistory
| private

Definition at line 52 of file ServiceHistory.h.

std::string ServiceHistory::m_name
| private

Definition at line 53 of file ServiceHistory.h.

PropertyList ServiceHistory::m_properties
| private

Definition at line 54 of file ServiceHistory.h.

const IService* ServiceHistory::m_pService
| private

Definition at line 51 of file ServiceHistory.h.

std::string ServiceHistory::m_type
| private

Definition at line 53 of file ServiceHistory.h.

std::string ServiceHistory::m_version
| private

Definition at line 53 of file ServiceHistory.h.

The documentation for this class was generated from the following files:

- GaudiKernel/GaudiKernel/ServiceHistory.h
- GaudiKernel/src/Lib/ServiceHistory.cpp